
#include <Wire.h>
#include "MP1092.h"
#include "MP1091.h"

static MP1091_Segments MP1091_Digit_0;
static MP1091_Segments MP1091_Digit_1;
static MP1091_Segments MP1091_Digit_2;
static MP1091_Segments MP1091_Digit_3;
static MP1091_Segments MP1091_Digit_4;
static MP1091_Segments MP1091_Digit_5;
static MP1091_Segments MP1091_Digit_6;
static MP1091_Segments MP1091_Digit_7;
static MP1091_Segments MP1091_Digit_8;
static MP1091_Segments MP1091_Digit_9;

static byte MP1091_DIG1;
static byte MP1091_DIG2;
static byte MP1091_DIG3;
static byte MP1091_DIG4;
static byte MP1091_DP;
static byte MP1091_PP;
                                         
static byte MP1091_Configuration;


MP1091::MP1091 ()
{

}
// PUBLIC FUNCTIONS

// void MP1091::Config (byte Configuration)
//     MP1091
//  :
// byte Configuration -    MP1091
//    0 -    MP1091    MP1092
//    1 -    MP1091    /  Arduino
//    2 -  MP1091    MP1092,
//         MP1091    /  Arduino 
void MP1091::Config (byte Configuration)
{
   MP1091_Configuration = Configuration;
}
//------------------------------------------------------------------------------
// void MP1091::SegConfig (byte Seg_a, byte Seg_b, byte Seg_c, byte Seg_d, byte Seg_e, byte Seg_f, byte Seg_g, byte Seg_dp, byte Seg_pp)
//   /,      MP1091
//  :
// byte Seg_a, byte Seg_b, byte Seg_c, byte Seg_d, byte Seg_e,
// byte Seg_f, byte Seg_g, byte Seg_dp, byte Seg_pp -   /,
//     : 0, 1, 2  ..
//      MP1091   MP1092  
//  0...15.      MP1091   Arduino
//      /  Arduino.
void MP1091::SegConfig (byte Seg_a, byte Seg_b, byte Seg_c, byte Seg_d, byte Seg_e, byte Seg_f, byte Seg_g, byte Seg_dp, byte Seg_pp)
{

   if (MP1091_Configuration == ALL_GPIO)
   {
      pinMode(Seg_a, OUTPUT);
      pinMode(Seg_b, OUTPUT);
      pinMode(Seg_c, OUTPUT);
      pinMode(Seg_d, OUTPUT);
      pinMode(Seg_e, OUTPUT);
      pinMode(Seg_f, OUTPUT);
      pinMode(Seg_g, OUTPUT);
      pinMode(Seg_dp, OUTPUT);
      pinMode(Seg_pp, OUTPUT);
      
      digitalWrite(Seg_a, HIGH);
      digitalWrite(Seg_b, HIGH);
      digitalWrite(Seg_c, HIGH);
      digitalWrite(Seg_d, HIGH);
      digitalWrite(Seg_e, HIGH);
      digitalWrite(Seg_f, HIGH);
      digitalWrite(Seg_g, HIGH);
      digitalWrite(Seg_dp, HIGH);
      digitalWrite(Seg_pp, HIGH);
   }
   
   MP1091_DP = Seg_dp;
   MP1091_PP = Seg_pp;
   
   MP1091_Digit_0.A_SEG.SEG_PIN = Seg_a;
   MP1091_Digit_0.B_SEG.SEG_PIN = Seg_b;
   MP1091_Digit_0.C_SEG.SEG_PIN = Seg_c;
   MP1091_Digit_0.D_SEG.SEG_PIN = Seg_d;
   MP1091_Digit_0.E_SEG.SEG_PIN = Seg_e;
   MP1091_Digit_0.F_SEG.SEG_PIN = Seg_f;
   MP1091_Digit_0.G_SEG.SEG_PIN = Seg_g;
   
   
   MP1091_Digit_1.A_SEG.SEG_PIN = Seg_a;
   MP1091_Digit_1.B_SEG.SEG_PIN = Seg_b;
   MP1091_Digit_1.C_SEG.SEG_PIN = Seg_c;
   MP1091_Digit_1.D_SEG.SEG_PIN = Seg_d;
   MP1091_Digit_1.E_SEG.SEG_PIN = Seg_e;
   MP1091_Digit_1.F_SEG.SEG_PIN = Seg_f;
   MP1091_Digit_1.G_SEG.SEG_PIN = Seg_g;
   
   
   MP1091_Digit_2.A_SEG.SEG_PIN = Seg_a;
   MP1091_Digit_2.B_SEG.SEG_PIN = Seg_b;
   MP1091_Digit_2.C_SEG.SEG_PIN = Seg_c;
   MP1091_Digit_2.D_SEG.SEG_PIN = Seg_d;
   MP1091_Digit_2.E_SEG.SEG_PIN = Seg_e;
   MP1091_Digit_2.F_SEG.SEG_PIN = Seg_f;
   MP1091_Digit_2.G_SEG.SEG_PIN = Seg_g;
   
   
   MP1091_Digit_3.A_SEG.SEG_PIN = Seg_a;
   MP1091_Digit_3.B_SEG.SEG_PIN = Seg_b;
   MP1091_Digit_3.C_SEG.SEG_PIN = Seg_c;
   MP1091_Digit_3.D_SEG.SEG_PIN = Seg_d;
   MP1091_Digit_3.E_SEG.SEG_PIN = Seg_e;
   MP1091_Digit_3.F_SEG.SEG_PIN = Seg_f;
   MP1091_Digit_3.G_SEG.SEG_PIN = Seg_g;
   
   
   MP1091_Digit_4.A_SEG.SEG_PIN = Seg_a;
   MP1091_Digit_4.B_SEG.SEG_PIN = Seg_b;
   MP1091_Digit_4.C_SEG.SEG_PIN = Seg_c;
   MP1091_Digit_4.D_SEG.SEG_PIN = Seg_d;
   MP1091_Digit_4.E_SEG.SEG_PIN = Seg_e;
   MP1091_Digit_4.F_SEG.SEG_PIN = Seg_f;
   MP1091_Digit_4.G_SEG.SEG_PIN = Seg_g;
   
   
   MP1091_Digit_5.A_SEG.SEG_PIN = Seg_a;
   MP1091_Digit_5.B_SEG.SEG_PIN = Seg_b;
   MP1091_Digit_5.C_SEG.SEG_PIN = Seg_c;
   MP1091_Digit_5.D_SEG.SEG_PIN = Seg_d;
   MP1091_Digit_5.E_SEG.SEG_PIN = Seg_e;
   MP1091_Digit_5.F_SEG.SEG_PIN = Seg_f;
   MP1091_Digit_5.G_SEG.SEG_PIN = Seg_g;
   
   
   MP1091_Digit_6.A_SEG.SEG_PIN = Seg_a;
   MP1091_Digit_6.B_SEG.SEG_PIN = Seg_b;
   MP1091_Digit_6.C_SEG.SEG_PIN = Seg_c;
   MP1091_Digit_6.D_SEG.SEG_PIN = Seg_d;
   MP1091_Digit_6.E_SEG.SEG_PIN = Seg_e;
   MP1091_Digit_6.F_SEG.SEG_PIN = Seg_f;
   MP1091_Digit_6.G_SEG.SEG_PIN = Seg_g;
   
   
   MP1091_Digit_7.A_SEG.SEG_PIN = Seg_a;
   MP1091_Digit_7.B_SEG.SEG_PIN = Seg_b;
   MP1091_Digit_7.C_SEG.SEG_PIN = Seg_c;
   MP1091_Digit_7.D_SEG.SEG_PIN = Seg_d;
   MP1091_Digit_7.E_SEG.SEG_PIN = Seg_e;
   MP1091_Digit_7.F_SEG.SEG_PIN = Seg_f;
   MP1091_Digit_7.G_SEG.SEG_PIN = Seg_g;
   
   
   MP1091_Digit_8.A_SEG.SEG_PIN = Seg_a;
   MP1091_Digit_8.B_SEG.SEG_PIN = Seg_b;
   MP1091_Digit_8.C_SEG.SEG_PIN = Seg_c;
   MP1091_Digit_8.D_SEG.SEG_PIN = Seg_d;
   MP1091_Digit_8.E_SEG.SEG_PIN = Seg_e;
   MP1091_Digit_8.F_SEG.SEG_PIN = Seg_f;
   MP1091_Digit_8.G_SEG.SEG_PIN = Seg_g;
   
   
   MP1091_Digit_9.A_SEG.SEG_PIN = Seg_a;
   MP1091_Digit_9.B_SEG.SEG_PIN = Seg_b;
   MP1091_Digit_9.C_SEG.SEG_PIN = Seg_c;
   MP1091_Digit_9.D_SEG.SEG_PIN = Seg_d;
   MP1091_Digit_9.E_SEG.SEG_PIN = Seg_e;
   MP1091_Digit_9.F_SEG.SEG_PIN = Seg_f;
   MP1091_Digit_9.G_SEG.SEG_PIN = Seg_g;
   
   
//  0
   MP1091_Digit_0.A_SEG.MODE = 1;
   MP1091_Digit_0.B_SEG.MODE = 1;
   MP1091_Digit_0.C_SEG.MODE = 1;
   MP1091_Digit_0.D_SEG.MODE = 1;
   MP1091_Digit_0.E_SEG.MODE = 1;
   MP1091_Digit_0.F_SEG.MODE = 1;
   MP1091_Digit_0.G_SEG.MODE = 0;
   
//  1   
   MP1091_Digit_1.A_SEG.MODE = 0;
   MP1091_Digit_1.B_SEG.MODE = 1;
   MP1091_Digit_1.C_SEG.MODE = 1;
   MP1091_Digit_1.D_SEG.MODE = 0;
   MP1091_Digit_1.E_SEG.MODE = 0;
   MP1091_Digit_1.F_SEG.MODE = 0;
   MP1091_Digit_1.G_SEG.MODE = 0;
   
//  2   
   MP1091_Digit_2.A_SEG.MODE = 1;
   MP1091_Digit_2.B_SEG.MODE = 1;
   MP1091_Digit_2.C_SEG.MODE = 0;
   MP1091_Digit_2.D_SEG.MODE = 1;
   MP1091_Digit_2.E_SEG.MODE = 1;
   MP1091_Digit_2.F_SEG.MODE = 0;
   MP1091_Digit_2.G_SEG.MODE = 1;
   
//  3   
   MP1091_Digit_3.A_SEG.MODE = 1;
   MP1091_Digit_3.B_SEG.MODE = 1;
   MP1091_Digit_3.C_SEG.MODE = 1;
   MP1091_Digit_3.D_SEG.MODE = 1;
   MP1091_Digit_3.E_SEG.MODE = 0;
   MP1091_Digit_3.F_SEG.MODE = 0;
   MP1091_Digit_3.G_SEG.MODE = 1;
       
//  4   
   MP1091_Digit_4.A_SEG.MODE = 0;
   MP1091_Digit_4.B_SEG.MODE = 1;
   MP1091_Digit_4.C_SEG.MODE = 1;
   MP1091_Digit_4.D_SEG.MODE = 0;
   MP1091_Digit_4.E_SEG.MODE = 0;
   MP1091_Digit_4.F_SEG.MODE = 1;
   MP1091_Digit_4.G_SEG.MODE = 1;  
     
//  5   
   MP1091_Digit_5.A_SEG.MODE = 1;
   MP1091_Digit_5.B_SEG.MODE = 0;
   MP1091_Digit_5.C_SEG.MODE = 1;
   MP1091_Digit_5.D_SEG.MODE = 1;
   MP1091_Digit_5.E_SEG.MODE = 0;
   MP1091_Digit_5.F_SEG.MODE = 1;
   MP1091_Digit_5.G_SEG.MODE = 1;
    
//  6   
   MP1091_Digit_6.A_SEG.MODE = 1;
   MP1091_Digit_6.B_SEG.MODE = 0;
   MP1091_Digit_6.C_SEG.MODE = 1;
   MP1091_Digit_6.D_SEG.MODE = 1;
   MP1091_Digit_6.E_SEG.MODE = 1;
   MP1091_Digit_6.F_SEG.MODE = 1;
   MP1091_Digit_6.G_SEG.MODE = 1;
       
//  7   
   MP1091_Digit_7.A_SEG.MODE = 1;
   MP1091_Digit_7.B_SEG.MODE = 1;
   MP1091_Digit_7.C_SEG.MODE = 1;
   MP1091_Digit_7.D_SEG.MODE = 0;
   MP1091_Digit_7.E_SEG.MODE = 0;
   MP1091_Digit_7.F_SEG.MODE = 0;
   MP1091_Digit_7.G_SEG.MODE = 0;
   
//  8   
   MP1091_Digit_8.A_SEG.MODE = 1;
   MP1091_Digit_8.B_SEG.MODE = 1;
   MP1091_Digit_8.C_SEG.MODE = 1;
   MP1091_Digit_8.D_SEG.MODE = 1;
   MP1091_Digit_8.E_SEG.MODE = 1;
   MP1091_Digit_8.F_SEG.MODE = 1;
   MP1091_Digit_8.G_SEG.MODE = 1;
        
//  9   
   MP1091_Digit_9.A_SEG.MODE = 1;
   MP1091_Digit_9.B_SEG.MODE = 1;
   MP1091_Digit_9.C_SEG.MODE = 1;
   MP1091_Digit_9.D_SEG.MODE = 1;
   MP1091_Digit_9.E_SEG.MODE = 0;
   MP1091_Digit_9.F_SEG.MODE = 1;
   MP1091_Digit_9.G_SEG.MODE = 1;
}
//------------------------------------------------------------------------------
// void MP1091::AnodConfig (byte DIG1, byte DIG2, byte DIG3, byte DIG4)
//   /,      MP1091
//  :
// byte DIG1, byte DIG2, byte DIG3, byte DIG4 -   /,
//     : 0, 1, 2  ..
//      MP1091   MP1092  
//  0...15.      MP1091   Arduino
//      /  Arduino.
void MP1091::AnodConfig (byte DIG1, byte DIG2, byte DIG3, byte DIG4)
{   
   if ((MP1091_Configuration == ALL_GPIO) || (MP1091_Configuration == SEG_DRIVER_ANOD_GPIO))
   {
      pinMode(DIG1, OUTPUT);
      pinMode(DIG2, OUTPUT);
      pinMode(DIG3, OUTPUT);
      pinMode(DIG4, OUTPUT);
      
      digitalWrite(DIG1, HIGH);
      digitalWrite(DIG2, HIGH);
      digitalWrite(DIG3, HIGH);
      digitalWrite(DIG4, HIGH);
   }
   
   MP1091_DIG1 = DIG1;
   MP1091_DIG2 = DIG2;   
   MP1091_DIG3 = DIG3;
   MP1091_DIG4 = DIG4;      
}
//------------------------------------------------------------------------------
// void MP1091::ShowDigit (int MP1092_address, byte Digit, byte Mode, byte Position)
//    
//  :
//           int MP1092_address -  MP1092   I2C
//           (  R1, R3, R5;   0x60);
//           byte Digit -     ;    0  9
//           byte Mode -  : 0, 1, 2  3
//           0 -  ;
//           1 - ;
//           2 -     _0;
//           3 -     _1. 
//           :   2  3   
//                           MP1092
//           byte Position -   : 0, 1, 2  3  
void MP1091::ShowDigit (int MP1092_address, byte Digit, byte Mode, byte Position)
{
   MP1091_Segments DIGITS [10] = {MP1091_Digit_0, MP1091_Digit_1,
                                  MP1091_Digit_2, MP1091_Digit_3,
                                  MP1091_Digit_4, MP1091_Digit_5,
                                  MP1091_Digit_6, MP1091_Digit_7,
                                  MP1091_Digit_8, MP1091_Digit_9};
   
   if ((MP1091_Configuration == ALL_DRIVER) || (MP1091_Configuration == SEG_DRIVER_ANOD_GPIO))
   {
      if (Mode < 4)
      {
         DigitConfig (MP1092_address, DIGITS[Digit], Mode);
      
         if (MP1091_Configuration == ALL_DRIVER)
            ActivateDigitDriver (MP1092_address, Position);
         else
            ActivateDigit (Position);
      }
   }
}
//------------------------------------------------------------------------------
// void MP1091::ShowDigit (byte Digit, byte Mode, byte Position)
//    
//  :
//           byte Digit -     ;    0  9
//           byte Mode -  : 0  1
//           0 -  ;
//           1 - .
//           byte Position -   : 0, 1, 2  3  
void MP1091::ShowDigit (byte Digit, byte Mode, byte Position)
{
   MP1091_Segments DIGITS [10] = {MP1091_Digit_0, MP1091_Digit_1,
                                  MP1091_Digit_2, MP1091_Digit_3,
                                  MP1091_Digit_4, MP1091_Digit_5,
                                  MP1091_Digit_6, MP1091_Digit_7,
                                  MP1091_Digit_8, MP1091_Digit_9};
   
   if (MP1091_Configuration == ALL_GPIO)
   {
      if (Mode < 2)
      {
         DigitConfigGPIO (DIGITS[Digit], Mode);
   
         ActivateDigit (Position);
      }
   }
}
//------------------------------------------------------------------------------
// void MP1091::DPConfig (int MP1092_address, byte Mode, byte Position)
//  
//  :
//           int MP1092_address -  MP1092   I2C
//           (  R1, R3, R5;   0x60);
//           byte Mode -  : 0, 1, 2  3
//           0 -  ;
//           1 - ;
//           2 -     _0;
//           3 -     _1. 
//           :   2  3   
//                           MP1092
//           byte Position -   : 0, 1, 2  3  
void MP1091::DPConfig (int MP1092_address, byte Mode, byte Position)
{
   if ((MP1091_Configuration == ALL_DRIVER) || (MP1091_Configuration == SEG_DRIVER_ANOD_GPIO))
   {
      if (Mode < 4)
      {
         MP1092::LEDConfig (MP1092_address, MP1091_DP, Mode);
   
         if (MP1091_Configuration == ALL_DRIVER)
            ActivateDigitDriver (MP1092_address, Position);
         else
            ActivateDigit (Position);
      }
   }
}
//------------------------------------------------------------------------------
// void MP1091::DPConfig (byte Mode, byte Position)
//  
//  :
//           byte Mode -  : 0  1
//           0 -  ;
//           1 - .
//           byte Position -   : 0, 1, 2  3  
void MP1091::DPConfig (byte Mode, byte Position)
{
   if (MP1091_Configuration == ALL_GPIO)
   {
      if (Mode < 2)
      {
         digitalWrite (MP1091_DP, !Mode);
   
         ActivateDigit (Position);
      }
   }
}
//------------------------------------------------------------------------------
// void MP1091::PPConfig (int MP1092_address, byte Mode)
//  
//  :
//           int MP1092_address -  MP1092   I2C
//           (  R1, R3, R5;   0x60);
//           byte Mode -  : 0, 1, 2  3
//           0 -  ;
//           1 - ;
//           2 -     _0;
//           3 -     _1. 
//           :   2  3   
//                           MP1092
void MP1091::PPConfig (int MP1092_address, byte Mode)
{
   if ((MP1091_Configuration == ALL_DRIVER) || (MP1091_Configuration == SEG_DRIVER_ANOD_GPIO))
   {
      if (Mode < 4)
         MP1092::LEDConfig (MP1092_address, MP1091_PP, Mode);
   }
}
//------------------------------------------------------------------------------
// void MP1091::PPConfig (byte Mode)
//  
//  :
//           byte Mode -  : 0  1
//           0 -  ;
//           1 - .
void MP1091::PPConfig (byte Mode)
{
   if (MP1091_Configuration == ALL_GPIO)
   {
      if (Mode < 2)
         digitalWrite (MP1091_PP, !Mode);
   }
}
//------------------------------------------------------------------------------
// PRIVATE FUNCTIONS
//------------------------------------------------------------------------------
void MP1091::DigitConfig (int MP1092_address, MP1091_Segments DigitStruct, byte Mode)
{
   byte Seg_Pins [7] = {DigitStruct.A_SEG.SEG_PIN, DigitStruct.B_SEG.SEG_PIN,
                        DigitStruct.C_SEG.SEG_PIN, DigitStruct.D_SEG.SEG_PIN,
                        DigitStruct.E_SEG.SEG_PIN, DigitStruct.F_SEG.SEG_PIN,
                        DigitStruct.G_SEG.SEG_PIN};
   
   byte Seg_Modes [7] = {DigitStruct.A_SEG.MODE, DigitStruct.B_SEG.MODE,
                         DigitStruct.C_SEG.MODE, DigitStruct.D_SEG.MODE,
                         DigitStruct.E_SEG.MODE, DigitStruct.F_SEG.MODE,
                         DigitStruct.G_SEG.MODE};
   
   word LEDS_NewVal_LOW = 0x00;
   word LEDS_NewVal_HIGH = 0x00;
   word LEDS_NewValMask_LOW = 0x00;
   word LEDS_NewValMask_HIGH = 0x00;
   word LEDS_ReadVal_LOW = 0x00;
   word LEDS_ReadVal_HIGH = 0x00;
   
   byte ReadVals [4];
   int k = 0;
   
   
   for (int i=0; i<7; i++)
   {
      if (Mode == 0)
         Seg_Modes [i] = 0;
      
      else if ((Mode == 2) || (Mode == 3))
      {
         if (Seg_Modes [i] == 1)
            Seg_Modes [i] = Mode;
      }
       
      if (Seg_Pins[i] < 8)
      {
         LEDS_NewValMask_LOW |= 0x3 << (Seg_Pins [i] * 2);
         LEDS_NewVal_LOW |= Seg_Modes [i] << (Seg_Pins [i] * 2);
      }
      else if (Seg_Pins[i] >= 8)
      {
         LEDS_NewValMask_HIGH |= 0x3 << (Seg_Pins [i] * 2);
         LEDS_NewVal_HIGH |= Seg_Modes [i] << (Seg_Pins [i] * 2);
      }
   }
     
   Wire.beginTransmission(MP1092_address);
   Wire.write (MP1092_LS0 | MP1092_AUTO_INCR);
   Wire.endTransmission();
  
   Wire.requestFrom (MP1092_address, 4);
   
   while(Wire.available())
   {   
    ReadVals [k] = byte(Wire.read());
    k++;
   }
   
   LEDS_ReadVal_LOW = word (ReadVals [1], ReadVals [0]);
   LEDS_ReadVal_HIGH = word (ReadVals [3], ReadVals [2]);
   
   LEDS_ReadVal_LOW &= ~LEDS_NewValMask_LOW;
   LEDS_ReadVal_LOW |= LEDS_NewVal_LOW;
   
   LEDS_ReadVal_HIGH &= ~LEDS_NewValMask_HIGH;
   LEDS_ReadVal_HIGH |= LEDS_NewVal_HIGH;
   
   Wire.beginTransmission(MP1092_address);
   Wire.write (MP1092_LS0 | MP1092_AUTO_INCR);
   Wire.write (lowByte(LEDS_ReadVal_LOW));
   Wire.write (highByte(LEDS_ReadVal_LOW));
   Wire.write (lowByte(LEDS_ReadVal_HIGH));
   Wire.write (highByte(LEDS_ReadVal_HIGH));
   Wire.endTransmission();
}
//------------------------------------------------------------------------------
void MP1091::DigitConfigGPIO (MP1091_Segments DigitStruct, byte Mode)
{
   byte Seg_Pins [7] = {DigitStruct.A_SEG.SEG_PIN, DigitStruct.B_SEG.SEG_PIN,
                        DigitStruct.C_SEG.SEG_PIN, DigitStruct.D_SEG.SEG_PIN,
                        DigitStruct.E_SEG.SEG_PIN, DigitStruct.F_SEG.SEG_PIN,
                        DigitStruct.G_SEG.SEG_PIN};
   
   byte Seg_Modes [7] = {DigitStruct.A_SEG.MODE, DigitStruct.B_SEG.MODE,
                         DigitStruct.C_SEG.MODE, DigitStruct.D_SEG.MODE,
                         DigitStruct.E_SEG.MODE, DigitStruct.F_SEG.MODE,
                         DigitStruct.G_SEG.MODE};
   
      
   for (int i=0; i<7; i++)
   {
      if (Mode == 0)
         Seg_Modes [i] = 1;
      
      else if (Mode == 1)
         Seg_Modes [i] = !Seg_Modes [i];
      
      digitalWrite (Seg_Pins [i], Seg_Modes [i]);
   }
}
//------------------------------------------------------------------------------
void MP1091::ActivateDigit (byte Num)
{
   byte Anods [4] = {MP1091_DIG1, MP1091_DIG2, MP1091_DIG3, MP1091_DIG4};

   if ((MP1091_Configuration == ALL_GPIO) || (MP1091_Configuration == SEG_DRIVER_ANOD_GPIO))
   {  
     for (int i=0; i<4; i++)
       digitalWrite(Anods [i], HIGH);
    
     digitalWrite(Anods [Num], LOW);
   }
}
//------------------------------------------------------------------------------
void MP1091::ActivateDigitDriver (int MP1092_address, byte Num)
{
   byte Anods [4] = {MP1091_DIG1, MP1091_DIG2, MP1091_DIG3, MP1091_DIG4};

   for (int i=0; i<4; i++)
      MP1092::LEDConfig (MP1092_address, Anods [i], 0);
   
   MP1092::LEDConfig (MP1092_address, Anods [Num], 1);
}


MP1091 LED_Indicator = MP1091 ();
