#ifndef MP1091_h
#define MP1091_h

#include "Arduino.h"

#define   ALL_DRIVER             0
#define   ALL_GPIO               1
#define   SEG_DRIVER_ANOD_GPIO   2



typedef struct  {
  byte SEG_PIN;
  byte MODE;        
}   MP1091_LEDSettings;


typedef struct  { 
  MP1091_LEDSettings A_SEG;
  MP1091_LEDSettings B_SEG;
  MP1091_LEDSettings C_SEG;
  MP1091_LEDSettings D_SEG;
  MP1091_LEDSettings E_SEG;
  MP1091_LEDSettings F_SEG;
  MP1091_LEDSettings G_SEG;
} 	MP1091_Segments, *MP1091_SegmentsPtr;



class MP1091
{
  public:
     MP1091 ();
     static void DPConfig (int MP1092_address, byte Mode, byte Position);
     static void DPConfig (byte Mode, byte Position);
     static void PPConfig (int MP1092_address, byte Mode);
     static void PPConfig (byte Mode);
     static void ShowDigit (int MP1092_address, byte Digit, byte Mode, byte Position);
     static void ShowDigit (byte Digit, byte Mode, byte Position);
     static void Config (byte Configuration);
     static void SegConfig (byte Seg_a, byte Seg_b, byte Seg_c, byte Seg_d, byte Seg_e, byte Seg_f, byte Seg_g, byte Seg_dp, byte Seg_pp);
     static void AnodConfig (byte DIG1, byte DIG2, byte DIG3, byte DIG4);

  private:
     static void DigitConfig (int MP1092_address, MP1091_Segments DigitStruct, byte Mode);
     static void DigitConfigGPIO (MP1091_Segments DigitStruct, byte Mode);
     static void ActivateDigitDriver (int MP1092_address, byte Num);
     static void ActivateDigit (byte Num);
};

extern MP1091 LED_Indicator;

#endif
